def p(a,b):
    """renvoie la probabilité de victoire de A à partir de l'état [a,b] dans le problème historique des partis"""
    if a == 3:
        return 1
    elif b == 3:
        return 0
    else:
        return 0.5*p(a+1, b) + 0.5*p(a, b+1)


def partis(cible,a,b):
    """renvoie la probabilité de victoire de A à partir de l'état [a,b] dans le problème historique des partis pour un nombre de parties gagnantes égal à cible"""
    if a == cible:
        return 1
    elif b == cible:
        return 0
    else:
        return 0.5 * partis(cible, a+1, b) + 0.5 * partis(cible, a, b+1)

def montant_partis(pot,cible,a,b):
    """renvoie la répartition de la somme en cas d'arrêt du jeu à l'état [a,b] pour un nombre cible de victoires à atteindre"""
    montant_a = pot * partis(cible,a,b)
    montant_b = pot - montant_a
    return (montant_a, montant_b)

def partis_memo(cible,a,b):
    """calcule le tableau de probabilité à tous les états de jeu possibles et renvoie la probabilite demandée pour A"""
    cache = [[ 0 for l in range (cible)] + [0] for k in range(cible)] + [[1 for k in range(cible)]+[""]]
    for ligne in range(cible-1,-1,-1):
        for colonne in range(cible-1,-1,-1):
            if ligne == colonne:
                cache[ligne][colonne]= 0.5
            else:
                cache[ligne][colonne] =  0.5*cache[ligne+1][colonne] + 0.5*cache[ligne][colonne+1]
    return cache[a][b], cache[b][a]

def pos_diag(n):
    """détermine les listes des positions de chaque fausse diagonale"""
    colonne = n - 1
    ligne = n -1
    rang = 1
    liste = [[]]
    while ligne >= 0:
        if colonne >= 0:
            indice = (n, colonne)
            pos = [indice]
            for i in range(n-colonne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                pos = pos + [nouveau]
                indice  = nouveau
            colonne = colonne - 1
        else:
            indice = (ligne, 0)
            pos = [indice]
            for i in range(ligne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                pos = pos + [nouveau]
                indice  = nouveau
            ligne = ligne - 1
        liste = liste + [pos]
    return liste

def partis_diag(n,a,b):
    """calcule uniquement la diagonale courante jusqu'à atteindre celle contenant l'état [a,b] dans le cas d'une partie à n victoires"""
    colonne = n - 1
    ligne = n - 1
    dico = {(n,n-1):1, (n-1,n):0}
    liste_pos = []
    while (a,b) not in liste_pos and ligne >= 0:
        if colonne >= 0:
            indice = (n, colonne)
            liste_pos = [indice]
            for i in range(n-colonne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                liste_pos = liste_pos + [nouveau]
                indice  = nouveau
            colonne = colonne - 1
        else:
            indice = (ligne, 0)
            liste_pos = [indice]
            for i in range(ligne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                liste_pos = liste_pos + [nouveau]
                indice  = nouveau
            ligne = ligne - 1
        dico_ancien = dico
        dico = {}
        for pos in liste_pos:
            if pos[0] == n:
                dico[pos] = 1
            elif pos[1] == n:
                dico[pos] = 0
            else:
                dico[pos] = 0.5*dico_ancien[(pos[0] + 1, pos[1])] +0.5*dico_ancien[(pos[0], pos[1] + 1)]
    return dico[(a,b)]




