import sys, gc
import timeit

def partis_memo(cible,a,b):
    """calcule le tableau de probabilité à tous les états de jeu possibles et renvoie la probabilite demandée pour A"""
    cache = [[ 0 for l in range (cible)] + [0] for k in range(cible)] + [[1 for k in range(cible)]+[""]]
    for ligne in range(cible-1,-1,-1):
        for colonne in range(cible-1,-1,-1):
            if ligne == colonne:
                cache[ligne][colonne]= 0.5
            else:
                cache[ligne][colonne] =  0.5*cache[ligne+1][colonne] + 0.5*cache[ligne][colonne+1]
    return cache[a][b]

def pos_diag(n):
    """détermine les listes des positions de chaque fausse diagonale"""
    colonne = n - 1
    ligne = n -1
    rang = 1
    liste = [[]]
    while ligne >= 0:
        if colonne >= 0:
            indice = (n, colonne)
            pos = [indice]
            for i in range(n-colonne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                pos = pos + [nouveau]
                indice  = nouveau
            colonne = colonne - 1
        else:
            indice = (ligne, 0)
            pos = [indice]
            for i in range(ligne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                pos = pos + [nouveau]
                indice  = nouveau
            ligne = ligne - 1
        liste = liste + [pos]
    return liste

def partis_diag(n,a,b):
    """calcule uniquement la diagonale courante jusqu'à atteindre celle contenant l'état [a,b] dans le cas d'une partie à n victoires"""
    colonne = n - 1
    ligne = n - 1
    dico = {}
    liste_pos = []
    while (a,b) not in liste_pos and ligne >= 0:
        if colonne >= 0:
            indice = (n, colonne)
            liste_pos = [indice]
            for i in range(n-colonne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                liste_pos = liste_pos + [nouveau]
                indice  = nouveau
            colonne = colonne - 1
        else:
            indice = (ligne, 0)
            liste_pos = [indice]
            for i in range(ligne):
                nouveau = (indice[0] - 1, indice[1] + 1)
                liste_pos = liste_pos + [nouveau]
                indice  = nouveau
            ligne = ligne - 1
        dico_ancien = dico
        dico = {}
        for pos in liste_pos:
            if pos[0] == n:
                dico[pos] = 1
            elif pos[1] == n:
                dico[pos] = 0
            else:
                dico[pos] = 0.5*dico_ancien[(pos[0] + 1, pos[1])] +0.5*dico_ancien[(pos[0], pos[1] + 1)]
    return dico[(a,b)]


gc.collect()
before = sys.getallocatedblocks()

data1 = partis_diag(500,1,0)

diff2 = sys.getallocatedblocks() - before
print(f'{diff2} blocs supplémentaires alloués')

gc.collect()
before = sys.getallocatedblocks()

data1 = partis_memo(500,1,0)

diff1 = sys.getallocatedblocks() - before
print(f'{diff1} blocs supplémentaires alloués')

