import random

def partie():
    """simulation du lancer de chaque dé avec victoire pour A si la somme est paire, pour B si la somme est impaire"""
    lancer_A = random.randint(1,6)
    lancer_B = random.randint(1,6)
    somme = lancer_A + lancer_B
    if somme % 2 == 0:
        return "A"
    else:
        return "B"

def test_equite(nb_jeux):
    """teste l'équité du jeu par simulation"""
    victoires_A = 0
    victoires_B = 0
    for i in range(nb_jeux):
        jeu = partie()
        if jeu == "A":
            victoires_A = victoires_A + 1
        else:
            victoires_B = victoires_B + 1
    return (victoires_A / nb_jeux, victoires_B / nb_jeux)


def deroule_jeu():
    """renvoie les possibilités de jeux lorsqu'il manque une victoire à A et 3 victoires à B"""
    lancer = partie() # nouvelle manche
    if lancer == "A":
        return "A" # A a gagné la manche qu'il lui manquait et il a gagné la partie
    else: # B a gagné la manche et il lui manque 2 victoires (et 1 pour A)
        lancer = partie()
        if lancer == "A":# A a gagné la manche qu'il lui manquait et il a gagné la partie
            return "A"
        else: # B a gagné la manche et il lui manque 1 victoire (et 1 pour A)
            lancer = partie()
            if lancer == "A":# A a gagné la manche qu'il lui manquait et il a gagné la partie
                return "A"
            else:# B a gagné la manche et il a gagné la partie
                return "B"


def simulation_jeux(nb_jeux):
    """on simule un grand nombre de jeux pour connaitre la fréquence de victoire de chaque joueur"""
    victoires_A = 0 # penser à faire un copier/coller du test d'équité
    victoires_B = 0
    for k in range(nb_jeux):
        jeu = deroule_jeu()
        if jeu == "A":
            victoires_A = victoires_A + 1
        else:
            victoires_B = victoires_B + 1
    return (victoires_A / nb_jeux, victoires_B / nb_jeux)



